VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BladeEncoder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This class needs mdlBladeEncVB.bas
' Made by Michael(Giovi)

Private vSampleRate As Long
Private vMode As BE_MP3_MODE
Private VBitrate As Integer

Private BufferSamples As Long
Private MP3Buffer As Long, hbeStream As Long

Private WFileName As String, FileNum As Integer
Private MP3_Buffer() As Byte

Public Event MP3Buffer(Buffer() As Byte)

Private Sub Class_Initialize()
    InitializeDLL
    
    vSampleRate = -1
    vMode = -1
    VBitrate = -1
End Sub

Public Property Get FileName() As String
    FileName = WFileName
End Property

Public Property Let FileName(ByVal vNewValue As String)
    WFileName = vNewValue
End Property

Public Function InitStream(Optional SampleRate As Long = 44100, Optional Mode As BE_MP3_MODE = MP3_MODE_STEREO, Optional BitRate As Integer = 128) As Boolean
    If blInitStream(SampleRate, Mode, BitRate, BufferSamples, MP3Buffer, hbeStream) <> 0 Then Exit Function
    
    vSampleRate = SampleRate
    vMode = Mode
    VBitrate = BitRate
    
    If WFileName <> "" Then
        FileNum = FreeFile
        Open WFileName For Binary Access Write Lock Write As FileNum
    Else
        FileNum = 0
    End If
    
    InitStream = True
End Function

Public Function EncodeChunk(WAV_Buffer() As Integer) As Boolean
    Dim toWrite As Long, DSamples As Long, TSamples As Long, WSamples As Long
    DSamples = UBound(WAV_Buffer)
    
    If DSamples < BufferSamples Then
        ReDim MP3_Buffer(0 To MP3Buffer - 1)
        If blEncodeChunk(hbeStream, DSamples, WAV_Buffer(0), MP3_Buffer(0), toWrite) <> 0 Then Exit Function
        ReDim Preserve MP3_Buffer(0 To toWrite - 1)
        
        If FileNum <> 0 Then
            Put FileNum, , MP3_Buffer
        Else
            RaiseEvent MP3Buffer(MP3_Buffer)
        End If
    Else
        Do
            TSamples = IIf(DSamples > BufferSamples, BufferSamples, DSamples)
            ReDim MP3_Buffer(0 To MP3Buffer - 1)
            
            If blEncodeChunk(hbeStream, TSamples, WAV_Buffer(WSamples), MP3_Buffer(0), toWrite) <> 0 Then Exit Function
            If toWrite > 0 Then
                ReDim Preserve MP3_Buffer(0 To toWrite - 1)
            
                If FileNum <> 0 Then
                    Put FileNum, , MP3_Buffer
                Else
                    RaiseEvent MP3Buffer(MP3_Buffer)
                End If
'            Else
'                Debug.Print "toWrite = 0"
            End If
            
            WSamples = WSamples + TSamples
            DSamples = DSamples - TSamples
        Loop Until DSamples <= 0
    End If
    
    EncodeChunk = True
End Function

Public Function CloseStream() As Boolean
    Dim toWrite As Long
    
    If MP3Buffer > 0 Then
        ReDim MP3_Buffer(0 To MP3Buffer - 1)
        If blDeinitStream(hbeStream, MP3_Buffer(0), toWrite) <> 0 Then Exit Function
        
        If toWrite > 0 Then
            ReDim Preserve MP3_Buffer(0 To toWrite - 1)
            
            If FileNum <> 0 Then
                Put FileNum, , MP3_Buffer
            Else
                RaiseEvent MP3Buffer(MP3_Buffer)
            End If
        End If
    End If
    
    vSampleRate = -1
    vMode = -1
    VBitrate = -1
    
    If FileNum <> 0 Then Close FileNum
    FileNum = 0
    If blCloseStream(hbeStream) <> 0 Then
        Exit Function
    Else
        hbeStream = 0
    End If
    
    CloseStream = True
End Function

Private Sub Class_Terminate()
    If hbeStream <> 0 Then blCloseStream hbeStream
End Sub

Public Property Get Samples() As Long
    Samples = BufferSamples
End Property

Public Property Get SampleRate() As Long
    SampleRate = vSampleRate
End Property

Public Property Get Channels() As BE_MP3_MODE
    Channels = vMode
End Property

Public Property Get BitRate() As Integer
    BitRate = VBitrate
End Property
