Attribute VB_Name = "BladeEncVB"
Option Explicit

' This class needs BladeEncVB.DLL
' Made by Michael(Giovi)

Public Const BE_CONFIG_MP3 = 0

Public Const BE_ERR_SUCCESSFUL = &H0
Public Const BE_ERR_INVALID_FORMAT = &H1
Public Const BE_ERR_INVALID_FORMAT_PARAMETERS = &H2
Public Const BE_ERR_NO_MORE_HANDLES = &H3
Public Const BE_ERR_INVALID_HANDLE = &H4

' other constants
Public Const BE_MAX_HOMEPAGE = 256

' format specific variables
Public Const BE_MP3_MODE_STEREO = 0
Public Const BE_MP3_MODE_DUALCHANNEL = 2
Public Const BE_MP3_MODE_MONO = 3

Public Enum BE_MP3_MODE
    MP3_MODE_STEREO = BE_MP3_MODE_STEREO
    MP3_MODE_DUALCHANNEL = BE_MP3_MODE_DUALCHANNEL
    MP3_MODE_MONO = BE_MP3_MODE_MONO
End Enum

Public Type BE_CONFIG_MP3
    dwConfig As Long       ' Must be = BE_CONFIG_MP3 ( 0 )
    
    dwSampleRate As Long   ' 48000, 44100 and 32000 allowed
    byMode As Byte         ' BE_MP3_MODE_STEREO, BE_MP3_MODE_DUALCHANNEL, BE_MP3_MODE_MONO
    wBitrate As Integer    ' 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256 and 320 allowed
    
    bPrivate As Long
    bCRC As Long
    bCopyright As Long
    bOriginal As Long
End Type

Public Type BE_VERSION
    ' BladeEnc DLL Version number
    byDLLMajorVersion As Byte
    byDLLMinorVersion As Byte
    
    ' BladeEnc Engine Version Number
    byMajorVersion As Byte
    byMinorVersion As Byte
    
    ' DLL Release date
    byDay As Byte
    byMonth As Byte
    wYear As Integer
    
    ' BladeEnc Homepage URL
    zHomepage(0 To BE_MAX_HOMEPAGE) As Byte
End Type

Public Declare Function InitializeDLL Lib "BladeEncVB.dll" () As Long

Public Declare Function blInitStream Lib "BladeEncVB.dll" (ByVal SampleRate As Long, ByVal Mode As Byte, ByVal BitRate As Integer, dwSamples As Long, dwMP3Buffer As Long, hbeStream As Long) As Long
Public Declare Function blEncodeChunk Lib "BladeEncVB.dll" (ByVal hbeStream As Long, ByVal nSamples As Long, pSamples As Integer, pOutput As Byte, pdwOutput As Long) As Long
Public Declare Function blDeinitStream Lib "BladeEncVB.dll" (ByVal hbeStream As Long, pOutput As Byte, pdwOutput As Long) As Long
Public Declare Function blCloseStream Lib "BladeEncVB.dll" (ByVal hbeStream As Long) As Long
Public Declare Function blGetVersion Lib "BladeEncVB.dll" (Version As BE_VERSION) As Long
Public Declare Function ChangeSoundVolume Lib "BladeEncVB.dll" (pInOut As Integer, ByVal nSamples As Integer, ByVal nChannels As Integer, ByVal LVolume As Double, ByVal RVolume As Double) As Long
Public Declare Function ChangeSoundVolumeB Lib "BladeEncVB.dll" (pInOut As Byte, ByVal nSamples As Integer, ByVal nChannels As Integer, ByVal LVolume As Double, ByVal RVolume As Double) As Long
